Ruby: rb_vm_struct Struct Reference

Ruby 3.4.8p72 (2025-12-17 revision 995b59f66677d44767ce9faac6957e5543617ff9)

Data Fields
rb_vm_struct Struct Reference

## Data Fields
VALUE | self
struct { |
struct ccan_list_head set |
unsigned int cnt |
unsigned int blocking_cnt |
struct rb_ractor_struct * main_ractor |
struct rb_thread_struct * main_thread |
struct { |
rb_nativethread_lock_t lock |
struct rb_ractor_struct * lock_owner |
unsigned int lock_rec |
rb_nativethread_cond_t terminate_cond |
bool terminate_waiting |
bool barrier_waiting |
unsigned int barrier_cnt |
rb_nativethread_cond_t barrier_cond |
} sync |
struct { |
rb_nativethread_lock_t lock |
struct rb_ractor_struct * lock_owner |
bool locked |
rb_nativethread_cond_t cond |
unsigned int snt_cnt |
unsigned int dnt_cnt |
unsigned int running_cnt |
unsigned int max_cpu |
struct ccan_list_head grq |
unsigned int grq_cnt |
struct ccan_list_head running_threads |
struct ccan_list_head timeslice_threads |
struct ccan_list_head zombie_threads |
bool timeslice_wait_inf |
rb_nativethread_cond_t barrier_complete_cond |
rb_nativethread_cond_t barrier_release_cond |
bool barrier_waiting |
unsigned int barrier_waiting_cnt |
unsigned int barrier_serial |
} sched |
} | ractor |
rb_serial_t | fork_gen
struct ccan_list_head | waiting_fds
volatile int | ubf_async_safe
unsigned int | running: 1
unsigned int | thread_abort_on_exception: 1
unsigned int | thread_report_on_exception: 1
unsigned int | thread_ignore_deadlock: 1
VALUE | mark_object_ary
struct global_object_list * | global_object_list
const VALUE | special_exceptions [ruby_special_error_count]
VALUE | top_self
VALUE | load_path
VALUE | load_path_snapshot
VALUE | load_path_check_cache
VALUE | expanded_load_path
VALUE | loaded_features
VALUE | loaded_features_snapshot
VALUE | loaded_features_realpaths
VALUE | loaded_features_realpath_map
struct st_table * | loaded_features_index
struct st_table * | loading_table
struct st_table * | static_ext_inits
struct { |
VALUE cmd [RUBY_NSIG] |
} | trap_list |
struct rb_postponed_job_queue * | postponed_job_queue
int | src_encoding_index
struct ccan_list_head | workqueue
rb_nativethread_lock_t | workqueue_lock
VALUE | orig_progname
VALUE | progname
VALUE | coverages
VALUE | me2counter
int | coverage_mode
struct { |
struct rb_objspace * objspace |
struct gc_mark_func_data_struct { |
void * data |
void(* mark_func )(VALUE v, void *data) |
} mark_func_data |
} | gc |
rb_at_exit_list * | at_exit
st_table * | frozen_strings
const struct rb_builtin_function * | builtin_function_table
st_table * | ci_table
struct rb_id_table * | negative_cme_table
st_table * | overloaded_cme_table
st_table * | unused_block_warning_table
struct rb_id_table * | constant_cache
ID | inserting_constant_cache_id
const struct rb_callcache * | global_cc_cache_table [VM_GLOBAL_CC_CACHE_TABLE_SIZE]
struct { |
size_t thread_vm_stack_size |
size_t thread_machine_stack_size |
size_t fiber_vm_stack_size |
size_t fiber_machine_stack_size |
} | default_params |

## Detailed Description

Definition at line 666 of file vm_core.h.

## Field Documentation

## ◆ at_exit

rb_at_exit_list* rb_vm_struct::at_exit

Definition at line 792 of file vm_core.h.

## ◆ barrier_cnt

unsigned int rb_vm_struct::barrier_cnt

Definition at line 689 of file vm_core.h.

## ◆ barrier_complete_cond

rb_nativethread_cond_t rb_vm_struct::barrier_complete_cond

Definition at line 722 of file vm_core.h.

## ◆ barrier_cond

rb_nativethread_cond_t rb_vm_struct::barrier_cond

Definition at line 690 of file vm_core.h.

## ◆ barrier_release_cond

rb_nativethread_cond_t rb_vm_struct::barrier_release_cond

Definition at line 723 of file vm_core.h.

## ◆ barrier_serial

unsigned int rb_vm_struct::barrier_serial

Definition at line 726 of file vm_core.h.

## ◆ barrier_waiting

bool rb_vm_struct::barrier_waiting

Definition at line 688 of file vm_core.h.

## ◆ barrier_waiting_cnt

unsigned int rb_vm_struct::barrier_waiting_cnt

Definition at line 725 of file vm_core.h.

## ◆ blocking_cnt

unsigned int rb_vm_struct::blocking_cnt

Definition at line 672 of file vm_core.h.

## ◆ builtin_function_table

const struct rb_builtin_function* rb_vm_struct::builtin_function_table

Definition at line 796 of file vm_core.h.

## ◆ ci_table

st_table* rb_vm_struct::ci_table

Definition at line 798 of file vm_core.h.

## ◆ cmd

VALUE rb_vm_struct::cmd[RUBY_NSIG]

Definition at line 768 of file vm_core.h.

## ◆ cnt

unsigned int rb_vm_struct::cnt

Definition at line 671 of file vm_core.h.

## ◆ cond

rb_nativethread_cond_t rb_vm_struct::cond

Definition at line 700 of file vm_core.h.

## ◆ constant_cache

struct rb_id_table* rb_vm_struct::constant_cache

Definition at line 807 of file vm_core.h.

## ◆ coverage_mode

int rb_vm_struct::coverage_mode

Definition at line 782 of file vm_core.h.

## ◆ coverages

VALUE rb_vm_struct::coverages

Definition at line 781 of file vm_core.h.

## ◆ data

void* rb_vm_struct::data

Definition at line 787 of file vm_core.h.

## ◆ dnt_cnt

unsigned int rb_vm_struct::dnt_cnt

Definition at line 702 of file vm_core.h.

## ◆ expanded_load_path

VALUE rb_vm_struct::expanded_load_path

Definition at line 755 of file vm_core.h.

## ◆ fiber_machine_stack_size

size_t rb_vm_struct::fiber_machine_stack_size

Definition at line 824 of file vm_core.h.

## ◆ fiber_vm_stack_size

size_t rb_vm_struct::fiber_vm_stack_size

Definition at line 823 of file vm_core.h.

## ◆ fork_gen

rb_serial_t rb_vm_struct::fork_gen

Definition at line 734 of file vm_core.h.

## ◆ frozen_strings

st_table* rb_vm_struct::frozen_strings

Definition at line 794 of file vm_core.h.

## ◆ global_cc_cache_table

const struct rb_callcache* rb_vm_struct::global_cc_cache_table[VM_GLOBAL_CC_CACHE_TABLE_SIZE]

Definition at line 813 of file vm_core.h.

## ◆ global_object_list

struct global_object_list* rb_vm_struct::global_object_list

Definition at line 747 of file vm_core.h.

## ◆ grq

struct ccan_list_head rb_vm_struct::grq

Definition at line 707 of file vm_core.h.

## ◆ grq_cnt

unsigned int rb_vm_struct::grq_cnt

Definition at line 708 of file vm_core.h.

## ◆ inserting_constant_cache_id

ID rb_vm_struct::inserting_constant_cache_id

Definition at line 808 of file vm_core.h.

## ◆ load_path

VALUE rb_vm_struct::load_path

Definition at line 752 of file vm_core.h.

## ◆ load_path_check_cache

VALUE rb_vm_struct::load_path_check_cache

Definition at line 754 of file vm_core.h.

## ◆ load_path_snapshot

VALUE rb_vm_struct::load_path_snapshot

Definition at line 753 of file vm_core.h.

## ◆ loaded_features

VALUE rb_vm_struct::loaded_features

Definition at line 756 of file vm_core.h.

## ◆ loaded_features_index

struct st_table* rb_vm_struct::loaded_features_index

Definition at line 760 of file vm_core.h.

## ◆ loaded_features_realpath_map

VALUE rb_vm_struct::loaded_features_realpath_map

Definition at line 759 of file vm_core.h.

## ◆ loaded_features_realpaths

VALUE rb_vm_struct::loaded_features_realpaths

Definition at line 758 of file vm_core.h.

## ◆ loaded_features_snapshot

VALUE rb_vm_struct::loaded_features_snapshot

Definition at line 757 of file vm_core.h.

## ◆ loading_table

struct st_table* rb_vm_struct::loading_table

Definition at line 761 of file vm_core.h.

## ◆ lock

rb_nativethread_lock_t rb_vm_struct::lock

Definition at line 679 of file vm_core.h.

## ◆ lock_owner

struct rb_ractor_struct* rb_vm_struct::lock_owner

Definition at line 680 of file vm_core.h.

## ◆ lock_rec

unsigned int rb_vm_struct::lock_rec

Definition at line 681 of file vm_core.h.

## ◆ locked

bool rb_vm_struct::locked

Definition at line 698 of file vm_core.h.

## ◆ main_ractor

struct rb_ractor_struct* rb_vm_struct::main_ractor

Definition at line 674 of file vm_core.h.

## ◆ main_thread

struct rb_thread_struct* rb_vm_struct::main_thread

Definition at line 675 of file vm_core.h.

## ◆ mark_func

void(* rb_vm_struct::mark_func) (VALUE v, void *data)

Definition at line 788 of file vm_core.h.

## ◆ mark_object_ary

VALUE rb_vm_struct::mark_object_ary

Definition at line 746 of file vm_core.h.

## ◆ max_cpu

unsigned int rb_vm_struct::max_cpu

Definition at line 706 of file vm_core.h.

## ◆ me2counter

VALUE rb_vm_struct::me2counter

Definition at line 781 of file vm_core.h.

## ◆ negative_cme_table

struct rb_id_table* rb_vm_struct::negative_cme_table

Definition at line 799 of file vm_core.h.

## ◆ objspace

struct rb_objspace* rb_vm_struct::objspace

Definition at line 785 of file vm_core.h.

## ◆ orig_progname

VALUE rb_vm_struct::orig_progname

Definition at line 780 of file vm_core.h.

## ◆ overloaded_cme_table

st_table* rb_vm_struct::overloaded_cme_table

Definition at line 800 of file vm_core.h.

## ◆ postponed_job_queue

struct rb_postponed_job_queue* rb_vm_struct::postponed_job_queue

Definition at line 772 of file vm_core.h.

## ◆ progname

VALUE rb_vm_struct::progname

Definition at line 780 of file vm_core.h.

## ◆ running

unsigned int rb_vm_struct::running

Definition at line 740 of file vm_core.h.

## ◆ running_cnt

unsigned int rb_vm_struct::running_cnt

Definition at line 704 of file vm_core.h.

## ◆ running_threads

struct ccan_list_head rb_vm_struct::running_threads

Definition at line 711 of file vm_core.h.

## ◆ self

VALUE rb_vm_struct::self

Definition at line 667 of file vm_core.h.

## ◆ set

struct ccan_list_head rb_vm_struct::set

Definition at line 670 of file vm_core.h.

## ◆ snt_cnt

unsigned int rb_vm_struct::snt_cnt

Definition at line 701 of file vm_core.h.

## ◆ special_exceptions

const VALUE rb_vm_struct::special_exceptions[ruby_special_error_count]

Definition at line 748 of file vm_core.h.

## ◆ src_encoding_index

int rb_vm_struct::src_encoding_index

Definition at line 774 of file vm_core.h.

## ◆ static_ext_inits

struct st_table* rb_vm_struct::static_ext_inits

Definition at line 764 of file vm_core.h.

## ◆ terminate_cond

rb_nativethread_cond_t rb_vm_struct::terminate_cond

Definition at line 684 of file vm_core.h.

## ◆ terminate_waiting

bool rb_vm_struct::terminate_waiting

Definition at line 685 of file vm_core.h.

## ◆ thread_abort_on_exception

unsigned int rb_vm_struct::thread_abort_on_exception

Definition at line 741 of file vm_core.h.

## ◆ thread_ignore_deadlock

unsigned int rb_vm_struct::thread_ignore_deadlock

Definition at line 743 of file vm_core.h.

## ◆ thread_machine_stack_size

size_t rb_vm_struct::thread_machine_stack_size

Definition at line 822 of file vm_core.h.

## ◆ thread_report_on_exception

unsigned int rb_vm_struct::thread_report_on_exception

Definition at line 742 of file vm_core.h.

## ◆ thread_vm_stack_size

size_t rb_vm_struct::thread_vm_stack_size

Definition at line 821 of file vm_core.h.

## ◆ timeslice_threads

struct ccan_list_head rb_vm_struct::timeslice_threads

Definition at line 714 of file vm_core.h.

## ◆ timeslice_wait_inf

bool rb_vm_struct::timeslice_wait_inf

Definition at line 719 of file vm_core.h.

## ◆ top_self

VALUE rb_vm_struct::top_self

Definition at line 751 of file vm_core.h.

## ◆ ubf_async_safe

volatile int rb_vm_struct::ubf_async_safe

Definition at line 738 of file vm_core.h.

## ◆ unused_block_warning_table

st_table* rb_vm_struct::unused_block_warning_table

Definition at line 801 of file vm_core.h.

## ◆ waiting_fds

struct ccan_list_head rb_vm_struct::waiting_fds

Definition at line 735 of file vm_core.h.

## ◆ workqueue

struct ccan_list_head rb_vm_struct::workqueue

Definition at line 777 of file vm_core.h.

## ◆ workqueue_lock

rb_nativethread_lock_t rb_vm_struct::workqueue_lock

Definition at line 778 of file vm_core.h.

## ◆ zombie_threads

struct ccan_list_head rb_vm_struct::zombie_threads

Definition at line 716 of file vm_core.h.

The documentation for this struct was generated from the following file:

- vm_core.h